// reorder_args.h

#ifndef LQ_reorder_args_h
#define LQ_reorder_args_h

#include <LQ/cdecls.h>
LQ_BEGIN_CDECLS;

/** Rreorders args list so switches are first, returns the number of
 * switches.  May be useful for cases where the params need to be 
 * separated from the switches, but requires a work-around if switches 
 * also have params.
 * One way to handle that situation is to have: '--switch = param", 
 * which will be moved as though it were a single arg regardless of 
 * spacing (or lack thereof) between the '=' and the two outer strings.
 */

int reorder_args(int argc, char** argv);

LQ_END_CDECLS;

#endif // LQ_reorder_args_h

