// unparse_args.h

#ifndef LQ_unparse_args_h
#define LQ_unparse_args_h

#include <LQ/cdecls.h>

/** \file unparse_args.h
 * A utility to restore a continguous commandline from parsed args such as 
 * argc and argv from a main() function, though any list of args and an arg
 * count can be converted to a commandline.
 */

LQ_BEGIN_CDECLS;

/// sets cmdline string to concatenated args, returns 0 on success.
int unparse_args(char* cmdline, int limit, int argc, char** argv);

LQ_END_CDECLS;

#endif // LQ_unparse_args_h

