// Code based on the now defunct fltk version 2.0 filename stuff. -rs

#include <sys/stat.h> // stat
#include <malloc.h> // malloc()
#include <string.h> // strcmp()
#include <stdlib.h> // getenv()
#include <ctype.h>  // isalpha()

#include <LQ/filename.h>
//#include <LQ/Parser.h> // load last in list
#include <LQ/cdecls.h>
LQ_BEGIN_CDECLS;

bool filename_load(const char* filename, char** pbuf, size_t* pbufsize)
{
  //////////////////////////////////
  // load_file
  size_t bufsize = filename_size(filename);
  if(! bufsize)
    return false; // ERR_FILE_OPENR;
  
  char* buf = (char*)malloc(bufsize + 1);
  if(! buf)
    return false; // ERR_MALLOC;
  
  FILE* fp = fopen(filename, "rb");
  if(!fp)
    return false; // ERR_FILE_OPENR;
  
  fread(buf, bufsize, 1, fp);
  fclose(fp);
  
  buf[bufsize] = 0; // for text files
  *pbuf = buf;
  *pbufsize = bufsize;
  return true;
}

// Returns true if successful
bool filename_save(const char* filename, char* buf, size_t bufsize)
{
  FILE* fp = fopen(filename, "wb");
  if(!fp)
    return false;
  
  fwrite(buf, bufsize, 1, fp);
  fclose(fp);
  return true;
}


#if 0

// we need some custom parsing funcs
static bool copy_name ()
{
  using namespace Parser; // begin Parser namespace
  bool state1;
  // first char must be alpha or '_'
  state1 = true;
  do
  {
    if (isalpha (*obj.ip))
      break;
    if (obj_is ("_"))
      break;
    state1 = false;
  }while (0);      // once
  if (!state1)
    return obj.state = false;
  
  // the rest of the name
    obj_copy_nchars (1);
    while (isalnum (*obj.ip) || obj_is ("_"))
      obj_copy_nchars (1);
    return obj.state = true;
}

#endif // 0

LQ_END_CDECLS;
