#include <malloc.h> // malloc()

#include <LQ/unparse_args.h>

#include <errno.h> // errno
#include <string.h> // memcpy()

#include <LQ/cdecls.h>
LQ_BEGIN_CDECLS;

// returns 0 on success, or one of the following
// #define ENOMEM    12  /* Out of memory */
// #define E2BIG    7  /* Argument list too long */
// defined in /usr/include/asm-generic/errno-base.h

int unparse_args(char* cmdline, int limit, int argc, char** argv)
{
  int i; // loop index
  cmdline[0] = 0;
  if(argc < 2)
    return 0;
  
  char* buf = (char*) malloc(limit+256);
  if(!buf)
    return errno = ENOMEM;
  
  char* p = buf;
  char* stopat = buf+limit -1;
  
  for(i = 1; i < argc; i++)
  {
    p += sprintf(p, "%s ", argv[i]);
    if(p >= stopat)
    {
      free(buf);
      return errno = E2BIG;
    }
  }
  p[-1] = 0; // terminate
  memcpy(cmdline, buf, p-buf);
  free(buf);
  return 0;
}

LQ_END_CDECLS;
