// slist.h

#ifndef SLIST_H
#define SLIST_H

// TODO:
// slist_insert(char*** plist, s, idx)   -- insert new item at idx
// slist_moveList(plist1, idx, plist2, delete_flg)  -- overwrite and append,
//                                                 -- [empty or delete list2]
// slist_trim(plist, idx)                -- remove items from idx to end
// slist_shift(plist, n)                 -- remove first n items from list

// returns an initialized pointer to a list base
char** slist_new();

// removes item and deletes the base
void slist_delete(char** list);

// returns number of items in the list
int slist_count(char** list);

// removes items, does not resize or delete the base
void slist_clear(char** list);

// adds a new items at the end of the list
void slist_append(char*** plist, const char* s);

// removes (and frees) item at idx. Does not resize the list
void slist_remove(char*** plist, int idx);

// adds list list2 to list1, does not delete list that's added
void slist_addList(char*** plist1, char** list2);


// remove one trailing newline char from a string
static void trim_newline(char* buf);

// Loads list with strings from a piped command,
// returns 0 on success
int slist_readPipe(char*** plist, const char* pipecmd);

// writes list through pipe, returns 0 on success.
int slist_writePipe(char*** list, const char* syscmd);


#endif // SLIST_H
 
