
#include <stdio.h>  // printf()
#include <stdlib.h> // getenv()
#include <string.h> // strrchr()

void dbg(){}

char pad[256];
char HERE[256];

void cd(const char* dir)
{
  chdir(dir);
  setenv("PWD", (char*)get_current_dir_name(), 1);
}

void cd_dirname(const char* execpath)
{
  char* p;
  sprintf(pad, execpath);
  p = strrchr(pad, '/');
  if(p)
  {
    *p = 0; // needs some more checks.
    cd(pad);
  }
}

void do_check();

int main(int argc, char** argv)
{
  dbg();
  cd_dirname(argv[0]);
  cd("..");
  sprintf(HERE, getenv("PWD"));
  if(argc == 1 || strcmp(argv[1], "working"))
  {
    printf(
        "Only run this from the makefile as 'make <app>' where <app>\n"
        "is the name of the function minus the 'mktools' prefix.\n"
        "\n"
        "Press ENTER to abort now.\n"
        "\n");
        getchar();
        return 1;
  }
  do_check();
  return 0;
}

void do_check()
{
  int found = 0;
  int err = 1;
  do
  {
    FILE* fp = fopen("files.dat", "r");
    if(!fp) break;
    fseek(fp, 0, SEEK_END);
    size_t fsize = ftell(fp);
    fseek(fp, 0, SEEK_SET);
    char* buf = (char*)malloc(fsize+1);
    fread(buf, 1, fsize, fp);
    buf[fsize] = 0;
    if(strstr(buf, "/share/info/dir"))
      found++;
    err = 0;
  }while(0);
  if(err)
    printf("Can't find 'files.dat' file\n");
  else if(found)
  {
    printf("\n"
    "WARNING:\n"
    "   \n"
    "   The file share/info/dir exists in your 'files.dat'.  This file \n"
    "   cannot be processed by the current Makefile install function.\n"
    "\n"
    "   Recommend removing or renaming it for manual addition (using \n"
    "   texitools) after installation, or if you know your user has \n"
    "   texitools, you might want to add mk_post -install and -uninstall \n"
    "   functions to add and remove the directory entries correctly.\n"
    "\n"
    );
    getchar();
    return;
  }        
}
  