#!/bin/bash


###################################################
# generic param check
FILESDIR=`dirname "$0"`
OUTNAME=$1

if [[ $# != 1 ]] ; then
  echo "
        -create ide requires 1 <OUTNAME> parameter.
        Aborting..
 "
  exit 1
fi

###################################################
# generic files list func
# get files list minus init.sh and init.sh(backup)
files=`ls $FILESDIR | sed '/init.sh*/d'`

###################################################
# generic move and rename func 
# get the files and set OUTNAME in the files
for i in $files; do
  cp $FILESDIR/$i .
  fandr $i "%{OUTNAME}%" "$OUTNAME" 
done

###################################################
# custom finalize
# rename files as necessary
mv OUTNAME.kdevelop $OUTNAME.kdevelop

# ok..
exit 0
